//Caption: Program to find the Cross-correlation of two Sequences
clear all;
clc;
x = [1,2,1,1];       
L = length(x);
h1 = [1,1,2,1];
disp('The input sequence 1 =')
disp(x)
disp('The input sequence 2=')
disp(h1)

//Cross Correlation using Built-in function xcorr()

Y  = xcorr(x,h1)
disp('Cross Correlation using built-in function xcorr():')
disp(Y)

//Cross Correlation using Direct Formula Method
for i = 1:L
  h(L-i+1) = h1(i);
end
N = 2*L-1;
Rxy = zeros(1,N);
for i = L+1:N
   h(i) = 0;
end
for i = L+1:N
    x(i) = 0;
end

for n = 1:N
  for k = 1:N
    if(n >= k)
      Rxy(n) = Rxy(n)+x(n-k+1)*h(k);
    end
  end
end

disp('Cross Correlation Result using direct formula method is')
disp(Rxy)


//OUTPUT Test Case
//Result
//"The input sequence 1 ="
//
//   1.   2.   1.   1.
//
//  "The input sequence 2="
//
//   1.   1.   2.   1.
//
//  "Cross Correlation using built-in function xcorr():"
//
//   1.   4.   6.   6.   5.   2.   1.
//
//  "Cross Correlation Result using direct formula method is"
//
//   1.   4.   6.   6.   5.   2.   1.
